Time-stamp: <Sat Oct 18 1997 22:46:57 Stardate: [-30]0114.53 hwloidl>

Computing a list of prime numbers using the Sieve of Erathostenes.

Based on the NESL code presented in:
   Programming Parallel Algorithms
   by Guy E. Blelloch 
   in CACM 39(3), March 1996
   URL: http://www.cs.cmu.edu/~scandal/nesl/alg-numerical.html

\begin{code}

import Strategies

#ifdef ARGS
import System (getArgs)
#endif

primes :: Integer -> [Integer]
primes 2 = []
primes n = 
  let sqr_primes = primes (ceiling (sqrt (fromInteger n)))
      sieves = [ [2*p, 3*p .. n]  | p <- sqr_primes ] 
      flat_sieves = concat sieves
      result  = [ i | i <- [0..n], i `notElem` flat_sieves ]

      strategy r = parList rnf sqr_primes  `par`
		   parList rnf flat_sieves `par`
		   parList rnf result      `par`
		   r0 r
  in 
      drop 2 result `using` strategy


#ifdef ARGS
munch_args = getArgs >>= \[n] ->
	     return (read n)
#else
munch_args = return 1000
#endif


#ifdef PRINT
main = munch_args >>= \ n -> putStrLn (show (primes n))
#else
main = munch_args >>= \ n -> 
       let 
	  res = primes n
       in  
       putStr "Done\n" `demanding` (rnf res)
#endif

\end{code}

----------------------------------------------------------------------

The original NESL code:

function primes(n) =
if n == 2 then [] int
else 
  let sqr_primes = primes(ceil(sqrt(float(n))));
      sieves = {[2*p:n:p]: p in sqr_primes};
      flat_sieves = flatten(sieves);
      flags  = dist(t,n) <- {(i,f): i in flat_sieves};
  in drop({i in [0:n]; flags | flags}, 2) ;

primes(100);
